searchData={"items":[{"type":"module","title":"Membrane.H265.FFmpeg.Decoder","doc":"Membrane element that decodes video in H265 format. It is backed by decoder from FFmpeg.\n\nThe element expects the data for each frame (Access Unit) to be received in a separate buffer,\nso the parser (`Membrane.H265.Parser`) may be required in a pipeline before\ndecoder (e.g. when input is read from `Membrane.File.Source`).","ref":"Membrane.H265.FFmpeg.Decoder.html"},{"type":"module","title":"Element options - Membrane.H265.FFmpeg.Decoder","doc":"Passed via struct `t:Membrane.H265.FFmpeg.Decoder.t/0`\n\n- `use_shm?`  \n\n  ```\n  boolean()\n  ```\n  \n  Default value: `false`  \n  If true, native decoder will use shared memory (via `t:Shmex.t/0`) for storing frames","ref":"Membrane.H265.FFmpeg.Decoder.html#module-element-options"},{"type":"module","title":"Pads - Membrane.H265.FFmpeg.Decoder","doc":"### `:input`\n\nAccepted formats:\n```\n%H265{alignment: :au}\n```\n\nDirection: | `:input`\nAvailability: | `:always`\nFlow control: | `:auto`\n\n\n### `:output`\n\nAccepted formats:\n```\n%RawVideo{pixel_format: format, aligned: true} when format in [:I420, :I422]\n```\n\nDirection: | `:output`\nAvailability: | `:always`\nFlow control: | `:auto`","ref":"Membrane.H265.FFmpeg.Decoder.html#module-pads"},{"type":"function","title":"Membrane.H265.FFmpeg.Decoder.options/0","doc":"Returns description of options available for this module","ref":"Membrane.H265.FFmpeg.Decoder.html#options/0"},{"type":"type","title":"Membrane.H265.FFmpeg.Decoder.t/0","doc":"Struct containing options for `Membrane.H265.FFmpeg.Decoder`","ref":"Membrane.H265.FFmpeg.Decoder.html#t:t/0"},{"type":"module","title":"Membrane.H265.FFmpeg.Encoder","doc":"Membrane element that encodes raw video frames to H265 format.\n\nThe element expects each frame to be received in a separate buffer, so the parser\n(`Membrane.Element.RawVideo.Parser`) may be required in a pipeline before\nthe encoder (e.g. when input is read from `Membrane.File.Source`).\n\nAdditionally, the encoder has to receive proper stream_format with picture format and dimensions\nbefore any encoding takes place.\n\nPlease check `t:t/0` for available options.","ref":"Membrane.H265.FFmpeg.Encoder.html"},{"type":"module","title":"Element options - Membrane.H265.FFmpeg.Encoder","doc":"Passed via struct `t:Membrane.H265.FFmpeg.Encoder.t/0`\n\n- `crf`  \n\n  ```\n  0..51\n  ```\n  \n  Default value: `28`  \n  Constant rate factor that affects the quality of output stream.\n  Value of 0 is lossless compression while 51 offers the worst quality.\n  The range is exponential, so increasing the CRF value +6 results\n  in roughly half the bitrate / file size, while -6 leads\n  to roughly twice the bitrate.\n\n\n- `preset`  \n\n  ```\n  preset()\n  ```\n  \n  Default value: `:medium`  \n  Collection of predefined options providing certain encoding.\n  The slower the preset chosen, the higher compression for the\n  same quality can be achieved.\n\n\n\n- `profile`  \n\n  ```\n  H265.profile_t() | nil\n  ```\n  \n  Default value: `nil`  \n  Sets a limit on the features that the encoder will use to the ones supported in a provided H265 profile.\n  Said features will have to be supported by the decoder in order to decode the resulting video.\n  It may override other, more specific options affecting compression.\n\n\n\n- `tune`  \n\n  ```\n  tune() | nil\n  ```\n  \n  Default value: `nil`  \n  Optionally tune the encoder settings for a particular type of source or situation.\n  See [`x265` encoder's man page](https://manpages.ubuntu.com/manpages/trusty/man1/x265.1.html) for more info.\n  Available options are:\n  - `:grain` - preserves the grain structure in old, grainy film material\n  - `:fastdecode` - allows faster decoding by disabling certain filters\n  - `:zerolatency` - good for fast encoding and low-latency streaming\n\n\n\n- `use_shm?`  \n\n  ```\n  boolean()\n  ```\n  \n  Default value: `false`  \n  If true, native encoder will use shared memory (via `t:Shmex.t/0`) for storing frames\n\n\n\n- `max_b_frames`  \n\n  ```\n  non_neg_integer() | nil\n  ```\n  \n  Default value: `nil`  \n  Maximum number of B-frames between non-B-frames. Set to 0 to encode video without b-frames\n\n\n\n- `gop_size`  \n\n  ```\n  non_neg_integer() | nil\n  ```\n  \n  Default value: `nil`  \n  Number of frames in a group of pictures.\n\n\n\n- `x265_params`  \n\n  ```\n  binary()\n  ```\n  \n  Default value: `\"\"`  \n  Set x265 options using a list of key=value couples separated by \":\".\n  See `x265 --help` for a list of options.","ref":"Membrane.H265.FFmpeg.Encoder.html#module-element-options"},{"type":"module","title":"Pads - Membrane.H265.FFmpeg.Encoder","doc":"### `:input`\n\nAccepted formats:\n```\n%RawVideo{pixel_format: format, aligned: true} when format in [:I420, :I422]\n```\n\nDirection: | `:input`\nAvailability: | `:always`\nFlow control: | `:auto`\n\n\n### `:output`\n\nAccepted formats:\n```\n%H265{alignment: :au}\n```\n\nDirection: | `:output`\nAvailability: | `:always`\nFlow control: | `:auto`","ref":"Membrane.H265.FFmpeg.Encoder.html#module-pads"},{"type":"function","title":"Membrane.H265.FFmpeg.Encoder.options/0","doc":"Returns description of options available for this module","ref":"Membrane.H265.FFmpeg.Encoder.html#options/0"},{"type":"type","title":"Membrane.H265.FFmpeg.Encoder.preset/0","doc":"","ref":"Membrane.H265.FFmpeg.Encoder.html#t:preset/0"},{"type":"type","title":"Membrane.H265.FFmpeg.Encoder.t/0","doc":"Struct containing options for `Membrane.H265.FFmpeg.Encoder`","ref":"Membrane.H265.FFmpeg.Encoder.html#t:t/0"},{"type":"type","title":"Membrane.H265.FFmpeg.Encoder.tune/0","doc":"","ref":"Membrane.H265.FFmpeg.Encoder.html#t:tune/0"},{"type":"extras","title":"Membrane H265 FFmpeg plugin","doc":"# Membrane H265 FFmpeg plugin\n\n[![Hex.pm](https://img.shields.io/hexpm/v/membrane_h265_ffmpeg_plugin.svg)](https://hex.pm/packages/membrane_h265_ffmpeg_plugin)\n[![API Docs](https://img.shields.io/badge/api-docs-yellow.svg?style=flat)](https://hexdocs.pm/membrane_h265_ffmpeg_plugin/)\n\nThis package provides H265 video decoder and encoder, based on [ffmpeg](https://www.ffmpeg.org).\n\nDocumentation is available at [HexDocs](https://hexdocs.pm/membrane_h265_ffmpeg_plugin/)","ref":"readme.html"},{"type":"extras","title":"Installation - Membrane H265 FFmpeg plugin","doc":"Add the following line to your `deps` in `mix.exs`. Run `mix deps.get`.\n\n```elixir\n{:membrane_h265_ffmpeg_plugin, \"~> 0.4.1\"}\n```\n\nThis package depends on the [ffmpeg](https://www.ffmpeg.org) libraries. The precompiled builds will be pulled and linked automatically. However, should there be any problems, consider installing it manually.\n\n#","ref":"readme.html#installation"},{"type":"extras","title":"Manual instalation of dependencies - Membrane H265 FFmpeg plugin","doc":"##","ref":"readme.html#manual-instalation-of-dependencies"},{"type":"extras","title":"Ubuntu - Membrane H265 FFmpeg plugin","doc":"```bash\nsudo apt-get install libavcodec-dev libavformat-dev libavutil-dev\n```\n\n##","ref":"readme.html#ubuntu"},{"type":"extras","title":"Arch/Manjaro - Membrane H265 FFmpeg plugin","doc":"```bash\npacman -S ffmpeg\n```\n\n##","ref":"readme.html#arch-manjaro"},{"type":"extras","title":"MacOS - Membrane H265 FFmpeg plugin","doc":"```bash\nbrew install ffmpeg\n```","ref":"readme.html#macos"},{"type":"extras","title":"Usage Example - Membrane H265 FFmpeg plugin","doc":"#","ref":"readme.html#usage-example"},{"type":"extras","title":"Decoder - Membrane H265 FFmpeg plugin","doc":"The following pipeline takes 30fps H265 file and decodes it to the raw video.\n\n```elixir\ndefmodule Decoding.Pipeline do\n  use Membrane.Pipeline\n\n  alias Membrane.H265\n\n  @impl true\n  def handle_init(_ctx, _opts) do\n    structure =\n      child(:source, %Membrane.File.Source{chunk_size: 40_960, location: \"input.h265\"})\n      |> child(:parser, H265.Parser)\n      |> child(:decoder, H265.FFmpeg.Decoder)\n      |> child(:sink,  %Membrane.File.Sink{location: \"output.raw\"})\n\n    {[spec: structure], %{}}\n  end\nend\n```\n\n#","ref":"readme.html#decoder"},{"type":"extras","title":"Encoder - Membrane H265 FFmpeg plugin","doc":"The following pipeline takes 720p raw video file as input and encodes it as H265.\n\n```elixir\ndefmodule Encoding.Pipeline do\n  use Membrane.Pipeline\n\n  @impl true\n  def handle_init(_) do\n    structure =\n      child(:source, %Membrane.File.Source{chunk_size: 40_960, location: \"input.raw\"})\n      |> child(:parser, %Membrane.RawVideo.Parser{width: 1280, height: 720, pixel_format: :I420})\n      |> child(:encoder, %Membrane.H265.FFmpeg.Encoder{preset: :fast, crf: 30})\n      |> child(:sink, %Membrane.File.Sink{location: \"output.h265\"})\n\n    {[spec: structure], %{}}\n  end\nend\n```","ref":"readme.html#encoder"},{"type":"extras","title":"LICENSE","doc":"Apache License\n                           Version 2.0, January 2004\n                        http://www.apache.org/licenses/\n\n   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION\n\n   1. Definitions.\n\n      \"License\" shall mean the terms and conditions for use, reproduction,\n      and distribution as defined by Sections 1 through 9 of this document.\n\n      \"Licensor\" shall mean the copyright owner or entity authorized by\n      the copyright owner that is granting the License.\n\n      \"Legal Entity\" shall mean the union of the acting entity and all\n      other entities that control, are controlled by, or are under common\n      control with that entity. For the purposes of this definition,\n      \"control\" means (i) the power, direct or indirect, to cause the\n      direction or management of such entity, whether by contract or\n      otherwise, or (ii) ownership of fifty percent (50%) or more of the\n      outstanding shares, or (iii) beneficial ownership of such entity.\n\n      \"You\" (or \"Your\") shall mean an individual or Legal Entity\n      exercising permissions granted by this License.\n\n      \"Source\" form shall mean the preferred form for making modifications,\n      including but not limited to software source code, documentation\n      source, and configuration files.\n\n      \"Object\" form shall mean any form resulting from mechanical\n      transformation or translation of a Source form, including but\n      not limited to compiled object code, generated documentation,\n      and conversions to other media types.\n\n      \"Work\" shall mean the work of authorship, whether in Source or\n      Object form, made available under the License, as indicated by a\n      copyright notice that is included in or attached to the work\n      (an example is provided in the Appendix below).\n\n      \"Derivative Works\" shall mean any work, whether in Source or Object\n      form, that is based on (or derived from) the Work and for which the\n      editorial revisions, annotations, elaborations, or other modifications\n      represent, as a whole, an original work of authorship. For the purposes\n      of this License, Derivative Works shall not include works that remain\n      separable from, or merely link (or bind by name) to the interfaces of,\n      the Work and Derivative Works thereof.\n\n      \"Contribution\" shall mean any work of authorship, including\n      the original version of the Work and any modifications or additions\n      to that Work or Derivative Works thereof, that is intentionally\n      submitted to Licensor for inclusion in the Work by the copyright owner\n      or by an individual or Legal Entity authorized to submit on behalf of\n      the copyright owner. For the purposes of this definition, \"submitted\"\n      means any form of electronic, verbal, or written communication sent\n      to the Licensor or its representatives, including but not limited to\n      communication on electronic mailing lists, source code control systems,\n      and issue tracking systems that are managed by, or on behalf of, the\n      Licensor for the purpose of discussing and improving the Work, but\n      excluding communication that is conspicuously marked or otherwise\n      designated in writing by the copyright owner as \"Not a Contribution.\"\n\n      \"Contributor\" shall mean Licensor and any individual or Legal Entity\n      on behalf of whom a Contribution has been received by Licensor and\n      subsequently incorporated within the Work.\n\n   2. Grant of Copyright License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      copyright license to reproduce, prepare Derivative Works of,\n      publicly display, publicly perform, sublicense, and distribute the\n      Work and such Derivative Works in Source or Object form.\n\n   3. Grant of Patent License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      (except as stated in this section) patent license to make, have made,\n      use, offer to sell, sell, import, and otherwise transfer the Work,\n      where such license applies only to those patent claims licensable\n      by such Contributor that are necessarily infringed by their\n      Contribution(s) alone or by combination of their Contribution(s)\n      with the Work to which such Contribution(s) was submitted. If You\n      institute patent litigation against any entity (including a\n      cross-claim or counterclaim in a lawsuit) alleging that the Work\n      or a Contribution incorporated within the Work constitutes direct\n      or contributory patent infringement, then any patent licenses\n      granted to You under this License for that Work shall terminate\n      as of the date such litigation is filed.\n\n   4. Redistribution. You may reproduce and distribute copies of the\n      Work or Derivative Works thereof in any medium, with or without\n      modifications, and in Source or Object form, provided that You\n      meet the following conditions:\n\n      (a) You must give any other recipients of the Work or\n          Derivative Works a copy of this License; and\n\n      (b) You must cause any modified files to carry prominent notices\n          stating that You changed the files; and\n\n      (c) You must retain, in the Source form of any Derivative Works\n          that You distribute, all copyright, patent, trademark, and\n          attribution notices from the Source form of the Work,\n          excluding those notices that do not pertain to any part of\n          the Derivative Works; and\n\n      (d) If the Work includes a \"NOTICE\" text file as part of its\n          distribution, then any Derivative Works that You distribute must\n          include a readable copy of the attribution notices contained\n          within such NOTICE file, excluding those notices that do not\n          pertain to any part of the Derivative Works, in at least one\n          of the following places: within a NOTICE text file distributed\n          as part of the Derivative Works; within the Source form or\n          documentation, if provided along with the Derivative Works; or,\n          within a display generated by the Derivative Works, if and\n          wherever such third-party notices normally appear. The contents\n          of the NOTICE file are for informational purposes only and\n          do not modify the License. You may add Your own attribution\n          notices within Derivative Works that You distribute, alongside\n          or as an addendum to the NOTICE text from the Work, provided\n          that such additional attribution notices cannot be construed\n          as modifying the License.\n\n      You may add Your own copyright statement to Your modifications and\n      may provide additional or different license terms and conditions\n      for use, reproduction, or distribution of Your modifications, or\n      for any such Derivative Works as a whole, provided Your use,\n      reproduction, and distribution of the Work otherwise complies with\n      the conditions stated in this License.\n\n   5. Submission of Contributions. Unless You explicitly state otherwise,\n      any Contribution intentionally submitted for inclusion in the Work\n      by You to the Licensor shall be under the terms and conditions of\n      this License, without any additional terms or conditions.\n      Notwithstanding the above, nothing herein shall supersede or modify\n      the terms of any separate license agreement you may have executed\n      with Licensor regarding such Contributions.\n\n   6. Trademarks. This License does not grant permission to use the trade\n      names, trademarks, service marks, or product names of the Licensor,\n      except as required for reasonable and customary use in describing the\n      origin of the Work and reproducing the content of the NOTICE file.\n\n   7. Disclaimer of Warranty. Unless required by applicable law or\n      agreed to in writing, Licensor provides the Work (and each\n      Contributor provides its Contributions) on an \"AS IS\" BASIS,\n      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\n      implied, including, without limitation, any warranties or conditions\n      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A\n      PARTICULAR PURPOSE. You are solely responsible for determining the\n      appropriateness of using or redistributing the Work and assume any\n      risks associated with Your exercise of permissions under this License.\n\n   8. Limitation of Liability. In no event and under no legal theory,\n      whether in tort (including negligence), contract, or otherwise,\n      unless required by applicable law (such as deliberate and grossly\n      negligent acts) or agreed to in writing, shall any Contributor be\n      liable to You for damages, including any direct, indirect, special,\n      incidental, or consequential damages of any character arising as a\n      result of this License or out of the use or inability to use the\n      Work (including but not limited to damages for loss of goodwill,\n      work stoppage, computer failure or malfunction, or any and all\n      other commercial damages or losses), even if such Contributor\n      has been advised of the possibility of such damages.\n\n   9. Accepting Warranty or Additional Liability. While redistributing\n      the Work or Derivative Works thereof, You may choose to offer,\n      and charge a fee for, acceptance of support, warranty, indemnity,\n      or other liability obligations and/or rights consistent with this\n      License. However, in accepting such obligations, You may act only\n      on Your own behalf and on Your sole responsibility, not on behalf\n      of any other Contributor, and only if You agree to indemnify,\n      defend, and hold each Contributor harmless for any liability\n      incurred by, or claims asserted against, such Contributor by reason\n      of your accepting any such warranty or additional liability.\n\n   END OF TERMS AND CONDITIONS\n\n   APPENDIX: How to apply the Apache License to your work.\n\n      To apply the Apache License to your work, attach the following\n      boilerplate notice, with the fields enclosed by brackets \"[]\"\n      replaced with your own identifying information. (Don't include\n      the brackets!)  The text should be enclosed in the appropriate\n      comment syntax for the file format. We also recommend that a\n      file or class name and description of purpose be included on the\n      same \"printed page\" as the copyright notice for easier\n      identification within third-party archives.\n\n   Copyright 2018 Software Mansion\n\n   Licensed under the Apache License, Version 2.0 (the \"License\");\n   you may not use this file except in compliance with the License.\n   You may obtain a copy of the License at\n\n       http://www.apache.org/licenses/LICENSE-2.0\n\n   Unless required by applicable law or agreed to in writing, software\n   distributed under the License is distributed on an \"AS IS\" BASIS,\n   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n   See the License for the specific language governing permissions and\n   limitations under the License.","ref":"license.html"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,49,46,50]}}